'use strict';

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _innerSlider = require('./inner-slider');

var _innerSlider2 = _interopRequireDefault(_innerSlider);

var _lodashSortby = require('lodash.sortby');

var _lodashSortby2 = _interopRequireDefault(_lodashSortby);

var _lodashPluck = require('lodash.pluck');

var _lodashPluck2 = _interopRequireDefault(_lodashPluck);

var _lodashFilter = require('lodash.filter');

var _lodashFilter2 = _interopRequireDefault(_lodashFilter);

var _lodashAssign = require('lodash.assign');

var _lodashAssign2 = _interopRequireDefault(_lodashAssign);

var _json2mq = require('json2mq');

var _json2mq2 = _interopRequireDefault(_json2mq);

var _reactResponsiveMixin = require('react-responsive-mixin');

var _reactResponsiveMixin2 = _interopRequireDefault(_reactResponsiveMixin);

var Slider = _react2['default'].createClass({
  displayName: 'Slider',

  mixins: [_reactResponsiveMixin2['default']],
  getInitialState: function getInitialState() {
    return {
      breakpoint: null
    };
  },
  componentDidMount: function componentDidMount() {
    var breakpoints = (0, _lodashSortby2['default'])((0, _lodashPluck2['default'])(this.props.responsive, 'breakpoint'));

    breakpoints.forEach((function (breakpoint, index) {
      var query;
      if (index === 0) {
        query = (0, _json2mq2['default'])({ minWidth: 0, maxWidth: breakpoint });
      } else {
        query = (0, _json2mq2['default'])({ minWidth: breakpoints[index - 1], maxWidth: breakpoint });
      }
      this.media(query, (function () {
        this.setState({ breakpoint: breakpoint });
      }).bind(this));
    }).bind(this));

    // Register media query for full screen. Need to support resize from small to large
    var query = (0, _json2mq2['default'])({ minWidth: breakpoints.slice(-1)[0] });

    this.media(query, (function () {
      this.setState({ breakpoint: null });
    }).bind(this));
  },
  render: function render() {
    var settings;
    var newProps;
    if (this.state.breakpoint) {
      newProps = (0, _lodashFilter2['default'])(this.props.responsive, { breakpoint: this.state.breakpoint });
      settings = (0, _lodashAssign2['default'])({}, this.props, newProps[0].settings);
    } else {
      settings = this.props;
    }
    return _react2['default'].createElement(_innerSlider2['default'], settings);
  }
});

module.exports = Slider;